#include "randomgen.h"

#include <time.h>
#include <iostream>
#include <cstdlib>
#include <math.h>

using namespace std;


CRandomGen::CRandomGen(void)
{
	// initialize the random seed
 	srand((unsigned int)time((time_t *)NULL));
}

CRandomGen::CRandomGen(unsigned int seed)
{
	// initialize the random seed
 	srand(seed);
}

CRandomGen::~CRandomGen(void)
{
}

float CRandomGen::nextDouble(float minValue, float maxValue)
{
	long data = 0;

	while((data = rand()) == 0)
	{
	}

	return((float)data / (RAND_MAX + 1.0) *
	       (maxValue - minValue) + minValue);
}

long CRandomGen::nextInt(long minValue, long maxValue)
{
	return(long((float)rand() / (RAND_MAX + 1.0) *
	            (maxValue - minValue) + minValue));
}

void CRandomGen::nextNormal(float& v1, float& v2)
{
	nextNormal(0.0, 1.0, -1.0, 1.0, v1, v2);
}

void CRandomGen::nextNormal(float mean, float var,
                            float minValue, float maxValue,
							float& v1, float& v2)
{
	float rsq = 0.0;
	float fac = 0.0;
	do
	{
		do
		{
			v1 = 2.0 * nextDouble(0.0, 1.0) - 1.0;
			v2 = 2.0 * nextDouble(0.0, 1.0) - 1.0;

			rsq = v1 * v1 + v2 * v2;
		} while (rsq >= 1.0 || rsq == 0.0);

		fac = sqrt(-2.0 * log(rsq) / rsq);

		v1 = v1 * fac * var + mean;
		v2 = v2 * fac * var + mean;
	} while (v1 < minValue || v1 > maxValue || v2 < minValue || v2 > maxValue);
}

float CRandomGen::nextZipf(float minValue, float maxValue, float z)
{
	float x = 0.0;
	float r =0.0;
	float HsubV = 0.0;
	float sum = 0.0;

	long V = 100;
	long i = 0;

	do
	{
		HsubV = 0.0;

		// calculate the V-th harmonic number HsubV. WARNING: V > 1
		for(i = 1; i <= V; i ++)
		{
			HsubV += 1.0 / pow((float)i, z);
		}

		r = nextDouble(0.0, 1.0) * HsubV;

		sum = 1.0;
		i = 1;
		while(sum < r)
		{
			i ++;
			sum += 1.0 / pow((float)i, z);
		}
	} while(i < 1 || i > V);
	// i follows Zipf distribution and lies between 1 and V

	// x lies between 0. and 1. and then between minValue and maxValue
	x = ((float)i - 1.0) / ((float)V - 1.0);
	x = (maxValue - minValue) * x + minValue;

	return(x);
}

